// vOsoba.h: interface for the vOsoba class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VOSOBA_H__C7493657_803E_11D6_9AD0_0080AD023781__INCLUDED_)
#define AFX_VOSOBA_H__C7493657_803E_11D6_9AD0_0080AD023781__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define MUZ		0
#define ZENA	1

#define MAX_IDSIZE		32

class vOsoba  
{
public:
	vOsoba();
	virtual ~vOsoba();

	void SetRokNar(int nRok) { m_rNarozeni = nRok; }
	void SetRokUmrti(int nRok) { m_rUmrti = nRok; }
	void SetID(const char* szID) { if (lstrlen(szID) > 16) AfxMessageBox("vOsoba::SetID() - prilis dlouhe ID osoby"); else lstrcpy(m_id, szID); }
	void SetJmeno(const char* szJmeno) { m_strJmeno = szJmeno; }
	void SetPrijmeni(const char* szPrijmeni) { m_strPrijmeni = szPrijmeni; }
	void SetPohlavi(int p) { m_nPohlavi = (BYTE) p; }
	//void SetParents(vOsoba* matka, vOsoba* otec) { m_osobaMatka = matka, m_osobaOtec = otec; }
	void SetMatka(const char* id) { lstrcpy(m_osobaMatka, id); }
	void SetOtec(const char* id) { lstrcpy(m_osobaOtec, id); }

	void Reset();

	const int GetRokNar() const { return m_rNarozeni; }
	const int GetRokUmrti() const { return m_rUmrti; }
	const char* GetID() const { return m_id; }
	const CString GetJmeno() const { return m_strJmeno; }
	const CString GetPrijmeni() const { return m_strPrijmeni; }
	const BYTE GetPohlavi() const { return m_nPohlavi; }
	const char* GetMatka() const { return m_osobaMatka; }
	const char* GetOtec() const { return m_osobaOtec; }
	CString GetFullName() const { CString tmp = m_strJmeno + " "; tmp += m_strPrijmeni; return tmp; }

	HTREEITEM m_hItem, m_hItemParent;
	bool m_bAdded;
	DWORD m_dwData; // Data pro jednoznacnou 4-bytovou identifikaci osoby

protected:
	int m_rNarozeni, m_rUmrti;
	char m_id[MAX_IDSIZE];
	CString m_strJmeno, m_strPrijmeni;
	BYTE m_nPohlavi;
	char m_osobaMatka[MAX_IDSIZE], m_osobaOtec[MAX_IDSIZE];
};

#endif // !defined(AFX_VOSOBA_H__C7493657_803E_11D6_9AD0_0080AD023781__INCLUDED_)
