// vRodokmen.cpp: implementation of the vRodokmen class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "20rkmn.h"
#include "vRodokmen.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

vRodokmen::vRodokmen()
{

}

vRodokmen::~vRodokmen()
{

}

bool vRodokmen::LoadFromFile(const char* fn)
{
	// vim ze by to bylo lepsi pres vyjimky ale na to neni cas..

	#define err(x) { AfxMessageBox(x, MB_ICONERROR); fclose(f); return false; }

	// 1. Otevrit soubor

	FILE* f = fopen(fn, "rt");

	if (!f)
	{
		AfxMessageBox("Soubor nelze otevrit");
		return false;
	}

	// 2. Nacist elementy

	char szTemp[4096], *szPtr;
	vOsoba osoba;
	bool bLoadingOsoba = false;

	while (fgets(szTemp, 4096, f))
	{
		szPtr = szTemp;
		int nLen = lstrlen(szTemp) - 1;

		// Preskocit whitespace na zacatku tagu
		while ((*szPtr == '\t' || *szPtr == ' ') && *szPtr != 0)
			szPtr++;

		if (*szPtr != '<')
			err("Chybn formt souboru");

		szPtr++;

		// Zkopirovat tag
		char szTag[128], szData[1024];
		int x = 0;

		while (*szPtr != '>')
			szTag[x++] = *szPtr++;

		// Ulozit tag

		szTag[x] = 0;
		szPtr++;

		// Zkopirovat data

		x = 0;
		while (*szPtr != '<' && *szPtr != 0)
			szData[x++] = *szPtr++;

		// Ulozit data

		szData[x] = 0;
		szPtr++; // ??

		//
		// Podle tagu se rozhodnout co delat dal
		//

		// Novy rodokmen
		if (!lstrcmpi(szTag, "rodokmen"))
		{
			m_vecOsoby.clear();
		}

		// Nova osoba
		if (!lstrcmpi(szTag, "osoba"))
		{
			bLoadingOsoba = true;
			osoba.Reset();
		}

		// Konec definice osoby
		if (!lstrcmpi(szTag, "/osoba"))
		{
			bLoadingOsoba = false;

			AddOsoba(&osoba);
		}

		// nacitani jednotlivych dat
		if (!lstrcmpi(szTag, "jmeno"))
		{
			if (!bLoadingOsoba)
				err("Neznm vlastnk - jmeno");

			osoba.SetJmeno(szData);
		}

		if (!lstrcmpi(szTag, "prijmeni"))
		{
			if (!bLoadingOsoba)
				err("Neznm vlastnk - prijmeni");

			osoba.SetPrijmeni(szData);
		}

		if (!lstrcmpi(szTag, "id"))
		{
			if (!bLoadingOsoba)
				err("Neznm vlastnk - id");

			osoba.SetID(szData);
		}

		if (!lstrcmpi(szTag, "pohlavi"))
		{
			if (!bLoadingOsoba)
				err("Neznm vlastnk - pohlavi");

			osoba.SetPohlavi(*szData != 'M');
		}

		if (!lstrcmpi(szTag, "narozeni"))
		{
			if (!bLoadingOsoba)
				err("Neznm vlastnk - pohlavi");

			osoba.SetRokNar(atoi(szData));
		}

		if (!lstrcmpi(szTag, "umrti"))
		{
			if (!bLoadingOsoba)
				err("Neznm vlastnk - umrti");

			osoba.SetRokUmrti(atoi(szData));
		}

		if (!lstrcmpi(szTag, "matka"))
		{
			if (!bLoadingOsoba)
				err("Neznm vlastnk - matka");

			osoba.SetMatka(szData);
		}

		if (!lstrcmpi(szTag, "otec"))
		{
			if (!bLoadingOsoba)
				err("Neznm vlastnk - otec");

			osoba.SetOtec(szData);
		}

	}

	fclose(f);

	// Rodokmen je nacten v pameti

	return true;
}


bool vRodokmen::SaveToFile(const char* fn)
{
	FILE* f = fopen(fn, "wt");

	if (!f)
	{
		AfxMessageBox("Soubor nelze otevrit");
		return false;
	}

	fprintf(f, "<rodokmen>\n");

	for (int x=0; x<m_vecOsoby.size(); x++)
	{
		vOsoba* o = &m_vecOsoby[x];
		// Ulozit osobu
		
		fprintf(f,"\t<osoba>\n");
		fprintf(f,"\t\t<id>%s</id>\n", o->GetID());
		fprintf(f,"\t\t<jmeno>%s</jmeno>\n", o->GetJmeno());
		fprintf(f,"\t\t<prijmeni>%s</prijmeni>\n", o->GetPrijmeni());
		fprintf(f,"\t\t<pohlavi>%c</pohlavi>\n", (o->GetPohlavi() == MUZ) ? 'M' : 'Z');
		fprintf(f,"\t\t<narozeni>%d</narozeni>\n", o->GetRokNar());

		if (o->GetRokUmrti())
			fprintf(f,"\t\t<umrti>%d</umrti>\n", o->GetRokUmrti());
		else
			fprintf(f,"\t\t<umrti/>\n");

		if (*o->GetMatka() != 0)
			fprintf(f,"\t\t<matka>%s</matka>\n", o->GetMatka());
		else
			fprintf(f,"\t\t<matka/>\n");

		if (*o->GetOtec() != 0)
			fprintf(f,"\t\t<otec>%s</otec>\n", o->GetOtec());
		else
			fprintf(f,"\t\t<otec/>\n");

		fprintf(f,"\t</osoba>\n");
	}

	fprintf(f, "</rodokmen>\n");

	fclose(f);

	return true;
}


vOsoba* vRodokmen::GetOsobaByID(const char *id)
{
	if (*id == 0)
		return NULL;

	for (int x=0; x<m_vecOsoby.size(); x++)
	{
		if (!lstrcmpi(m_vecOsoby[x].GetID(), id))
			return &m_vecOsoby[x];
	}

	return NULL;
}

vOsoba* vRodokmen::GetOsobaByTreeItem(HTREEITEM treeItem)
{
	for (int x=0; x<m_vecOsoby.size(); x++)
	{
		if (m_vecOsoby[x].m_hItem == treeItem)
			return &m_vecOsoby[x];
	}

	return NULL;
}

void vRodokmen::SetOsobaUserData(int nIndex, HTREEITEM htri, DWORD dwData)
{
	m_vecOsoby[nIndex].m_hItem = htri;
	m_vecOsoby[nIndex].m_bAdded = true;
	m_vecOsoby[nIndex].m_dwData = dwData;
}

void vRodokmen::FillTreeList(CTreeCtrl& treeList)
{
	int nCount = GetPocetOsob();

	treeList.SetRedraw(FALSE);
	treeList.DeleteAllItems();

	// Vynulovat priznaky pridani do treelistu
	for (int a=0; a<nCount; a++)
		m_vecOsoby[a].m_bAdded = false;

	DWORD dwData = 0;

	// Vyplnit treelist
	for (int y=0; y<nCount; y++)
		for (int x=0; x<nCount; x++)
		{
			const vOsoba* o = GetOsoba(x);

			// Pokud jiz byla pridana, podruhe nepridavat
			if (o->m_bAdded)
				continue;

			CString strFullName = o->GetFullName();

			vOsoba* otec = NULL;

			// Najit otce
			if (*o->GetOtec() != 0)
				otec = GetOsobaByID(o->GetOtec());

			// Pokud nema otce nebo otec jiz byl pridan do listu, tak pridat i potomka
			if (otec != NULL)
				if (otec->m_bAdded)
				{
					if (*o->GetMatka() != 0)
					{
						vOsoba* matka = GetOsobaByID(o->GetMatka());

						if (matka == NULL)
						{
							AfxMessageBox("Neexistujc matka", MB_ICONERROR);
							continue;
						}

						strFullName += " (matka ";
						strFullName += matka->GetFullName();
						strFullName += ")";
					}

					HTREEITEM item = treeList.InsertItem(strFullName, -1 ,-1, otec->m_hItem);

					SetOsobaUserData(x, item, dwData);
					treeList.SetItemData(item, dwData);

					dwData++;
				}
				else;
			else
			{
				HTREEITEM item = treeList.InsertItem(strFullName, -1 ,-1, TVI_ROOT);

				SetOsobaUserData(x, item, dwData);
				treeList.SetItemData(item, dwData);

				dwData++;
			}
		}

	treeList.SetRedraw(TRUE);
}

bool vRodokmen::RemoveOsoba(vOsoba* o)
{
	for (int x=0; x<m_vecOsoby.size(); x++)
	{
		if (!lstrcmpi(m_vecOsoby[x].GetID(), o->GetID()))
		{
			m_vecOsoby.erase(&m_vecOsoby[x]);
			return true;
		}
	}

	return false;
}

CString vRodokmen::GetFirstFreeID()
{
	char szID[MAX_IDSIZE];

	int x=0;

	do
	{
		wsprintf(szID, "I%d", ++x);
	}
	while (GetOsobaByID(szID) != NULL);

	return CString(szID);
}

bool vRodokmen::MaPotomky(vOsoba* o)
{
	CString szID = o->GetID();

	if (o->GetPohlavi() == ZENA)
		for (int x=0; x<m_vecOsoby.size(); x++)
		{
			if (szID == m_vecOsoby[x].GetMatka())
				return true;
		}
	else
		for (int x=0; x<m_vecOsoby.size(); x++)
		{
			if (szID == m_vecOsoby[x].GetOtec())
				return true;
		}

	return false;
}

// Vraci true pokud je b potomkem a
bool vRodokmen::PotomekOd(vOsoba* a, vOsoba* b)
{
	return false;
}

// Vraci true pokud osoby a a b spolu maji potomky
bool vRodokmen::MajiSpoluDeti(vOsoba* a, vOsoba* b)
{
	CString szID1 = a->GetID();
	CString szID2 = b->GetID();

	for (int x=0; x<m_vecOsoby.size(); x++)
	{
		if (szID1 == m_vecOsoby[x].GetMatka() && szID2 == m_vecOsoby[x].GetOtec())
			return true;
	}

	return false;
}

vOsoba* vRodokmen::NajdiPartnera(vOsoba* a)
{
	CString szID = a->GetID();

	// Vypada to hur, ale je to rychlejsi
	if (a->GetPohlavi() == MUZ)
		for (int x=0; x<m_vecOsoby.size(); x++)
		{
			if (szID == m_vecOsoby[x].GetOtec())
				return GetOsobaByID(m_vecOsoby[x].GetMatka());
		}
	else
		for (int x=0; x<m_vecOsoby.size(); x++)
		{
			if (szID == m_vecOsoby[x].GetMatka())
				return GetOsobaByID(m_vecOsoby[x].GetOtec());
		}

	return NULL;
}

vOsoba* vRodokmen::NajdiDite(vOsoba* a, int nPoradi, bool* bJsouDalsi)
{
	CString szID = a->GetID();

	int nFound = 0;
	vOsoba* toRet;

	// Vypada to hur, ale je to rychlejsi
	if (a->GetPohlavi() == MUZ)
		for (int x=0; x<m_vecOsoby.size(); x++)
		{
			if (szID == m_vecOsoby[x].GetOtec())
			{
				if (nFound == nPoradi)
				{
					toRet = &m_vecOsoby[x];
					if (bJsouDalsi) *bJsouDalsi = true;	
					return toRet;
				}

				nFound++;
			}
		}
	else
		for (int x=0; x<m_vecOsoby.size(); x++)
		{
			if (szID == m_vecOsoby[x].GetMatka())
			{
				if (nFound == nPoradi)
				{
					toRet = &m_vecOsoby[x];
					if (bJsouDalsi) *bJsouDalsi = true;	
					return toRet;
				}

				nFound++;
			}
		}

	if (bJsouDalsi) *bJsouDalsi = false;
	return NULL;
}

vOsoba* vRodokmen::NajdiOtce(vOsoba* a)
{
	return GetOsobaByID(a->GetOtec());
}

vOsoba* vRodokmen::NajdiDedecka(vOsoba* a)
{
	vOsoba* o = GetOsobaByID(a->GetOtec());

	if (!o)
		return NULL;

	return GetOsobaByID(o->GetOtec());
}

vOsoba* vRodokmen::NajdiVnouce(vOsoba* a)
{
	vOsoba* o = NajdiDite(a);

	if (!o)
		return NULL;

	return NajdiDite(o);
}

vOsoba* vRodokmen::NajdiBratranceNeboSestrenici(vOsoba* a)
{
	vOsoba* o = NajdiDedecka(a);

	if (!o)
		return NULL;

	return NajdiDite(o);
}
