// vRodokmen.h: interface for the vRodokmen class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VRODOKMEN_H__55715DD2_8045_11D6_9AD0_0080AD023781__INCLUDED_)
#define AFX_VRODOKMEN_H__55715DD2_8045_11D6_9AD0_0080AD023781__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <vector>
using namespace std;

#include "vOsoba.h"

class vRodokmen  
{
public:
	void SetOsobaUserData(int nIndex, HTREEITEM htri, DWORD dwData);
	vOsoba* GetOsobaByID(const char* id);
	vOsoba* GetOsobaByTreeItem(HTREEITEM treeItem);
	void FillTreeList(CTreeCtrl& treeList);
	__inline bool AddOsoba(vOsoba* osoba) { m_vecOsoby.push_back(*osoba); return true; }
	bool RemoveOsoba(vOsoba* o);
	bool ReplaceOsoba(vOsoba* o) { if (!RemoveOsoba(o)) return false; return AddOsoba(o); }
	CString GetFirstFreeID();
	bool SaveToFile(const char* fn);
	bool PotomekOd(vOsoba* a, vOsoba* b);
	bool MajiSpoluDeti(vOsoba* a, vOsoba* b);

	// Hledani
	vOsoba* NajdiPartnera(vOsoba* a);
	vOsoba* NajdiDite(vOsoba* a,  int nPoradi = 0, bool* bJsouDalsi=NULL);
	vOsoba* NajdiOtce(vOsoba* a);
	vOsoba* NajdiDedecka(vOsoba* a);
	vOsoba* NajdiVnouce(vOsoba* a);
	vOsoba* NajdiBratranceNeboSestrenici(vOsoba* a);


	vRodokmen();
	virtual ~vRodokmen();

	bool LoadFromFile(const char* fn);
	__inline const vOsoba* GetOsoba(int nIndex) { ASSERT(nIndex < m_vecOsoby.size()); return &m_vecOsoby[nIndex]; }
	__inline int GetPocetOsob() { return m_vecOsoby.size(); }

	bool MaPotomky(vOsoba* o);

protected:
	vector<vOsoba> m_vecOsoby;
};

#endif // !defined(AFX_VRODOKMEN_H__55715DD2_8045_11D6_9AD0_0080AD023781__INCLUDED_)
